/******************************************************
IAR V2.1+STM8S_StdPeriph_Lib_V2.1.0
Chip type           : STM8S003K3
Core Clock frequency: 16MHz
Project: 50...400Hz 3ph sw_gen
******************************************************/

#include "stm8s.h"
#include "iostm003.c"
#include <stdbool.h>
#include <math.h>

#define A       PD_ODR_ODR6
#define B       PD_ODR_ODR5
#define C       PD_ODR_ODR4
#define D       PD_ODR_ODR3
#define E       PD_ODR_ODR2
#define F       PD_ODR_ODR1
#define G       PF_ODR_ODR4
#define DP      PB_ODR_ODR7
#define N0      PA_ODR_ODR3
#define N1      PD_ODR_ODR7
#define N2      PE_ODR_ODR5

#define key0	PB_IDR_IDR4
#define key1	PB_IDR_IDR5


#define cpu_freq 16000000UL
#define cnt_res 0xff
#define pwm_freq  cpu_freq/(2*cnt_res)
#define base_freq 50 //Hz
#define s_step pwm_freq/(base_freq*2)
#define pwm_top cnt_res/2

u16 s_table [s_step/2];
u16 s_table_tmp [s_step/2];

enum btn_states {prs, rls, hold} btn0,btn1,btn2;
enum dmodes {run,norm,ocp} dev_st=run;

s16 def_tmp;

u8 tkey[3];//,tmr0,tmr1;
u16 tim0,tim1;


u8 dbuf[3]={0,0,'c'};
u8 dpp=0;

u8 x=0xff;
u16 step_exc=s_step;

bool cntfb=1, cntfb1=1;

#define msize 20
__no_init u16 ee_freq [msize] @ 0x4000;

inline static void gpio_cfg()
{
  PA_ODR = 1<<1; PA_DDR = 1<<3|1<<2|1<<1; PA_CR1=0xff;
  PB_ODR = 1<<5|1<<4; PB_DDR = 1<<7|1<<6|1<<2|1<<1|1;
  PC_ODR = 1<<7;
  PD_ODR = 0xff; PD_DDR = 0xff-1;  //BKIN

  PC_DDR=PD_DDR=PE_DDR=PF_DDR=0xff;
  PB_CR1=PC_CR1=PD_CR1=PE_CR1=PF_CR1=0xff; //push-pull|pullup
}
inline static void clk_cfg()
{
  CLK_DeInit();
  CLK->CKDIVR = 0;     //16MHz
  CLK->PCKENR1 = CLK_PCKENR1_TIM1|CLK_PCKENR1_TIM2;
}
inline static void t1_cfg()
{
  {
    TIM1->ARRH = 0;
    TIM1->ARRL = 0xff;

    TIM1->CCR1H=TIM1->CCR2H=TIM1->CCR3H=0;
    TIM1->CCR1L=TIM1->CCR2L=TIM1->CCR3L=0;

  }

    TIM1->CR1 = TIM1_COUNTERMODE_CENTERALIGNED1|TIM1_CR1_ARPE|TIM1_CR1_URS;
    TIM1->CR2 = TIM1_CR2_CCPC;
    TIM1->RCR = 1;

    TIM1->CCMR1=TIM1->CCMR2=TIM1->CCMR3 = TIM1_OCMODE_PWM1|TIM1_CCMR_OCxPE;

    TIM1->CCER1 = TIM1_CCER1_CC1E|TIM1_CCER1_CC1NE|TIM1_CCER1_CC2E|TIM1_CCER1_CC2NE;
    TIM1->CCER2 = TIM1_CCER2_CC3E|TIM1_CCER2_CC3NE;
    TIM1->EGR   = TIM1_EGR_COMG;
    TIM1->IER   = TIM1_IER_UIE;

    TIM1->BKR  = TIM1_BKR_OSSI|TIM1_BKR_OSSR|TIM1_BKR_BKE;
    TIM1->OISR = 0;
    TIM1->DTR  = 24;
    TIM1->CR1 |= TIM1_CR1_CEN;
    TIM1->BKR |= TIM1_LOCKLEVEL_3;
}
static inline void t2_cfg()
{
  TIM2->PSCR  = 1;
  TIM2->ARRH  = 6;
  TIM2->ARRL  = 0x40; //5000Hz
  TIM2->CR1   = TIM2_CR1_ARPE|TIM2_CR1_URS;
  TIM2->IER   = TIM2_IER_UIE;

  TIM2->CR1 |= TIM2_CR1_CEN;
}

void convert_data (u16 d)
{
u8 k;
  for (k=0;k<3;k++)
  {
   dbuf[k]=d%10;
   d/=10;
  }
}
void display_data ()
{
  static u8 pc;

  (pc)?(pc--):(pc = 2);
  N0=N1=N2=0; DP=1;

  switch (dbuf[pc])
 {
  case 0: A=0; B=0; C=0; D=0; E=0; F=0; G=1; break;
  case 1: A=1; B=0; C=0; D=1; E=1; F=1; G=1; break;
  case 2: A=0; B=0; C=1; D=0; E=0; F=1; G=0; break;
  case 3: A=0; B=0; C=0; D=0; E=1; F=1; G=0; break;
  case 4: A=1; B=0; C=0; D=1; E=1; F=0; G=0; break;
  case 5: A=0; B=1; C=0; D=0; E=1; F=0; G=0; break;
  case 6: A=0; B=1; C=0; D=0; E=0; F=0; G=0; break;
  case 7: A=0; B=0; C=0; D=1; E=1; F=1; G=1; break;
  case 8: A=0; B=0; C=0; D=0; E=0; F=0; G=0; break;
  case 9: A=0; B=0; C=0; D=0; E=1; F=0; G=0; break;
  case ' ': A=1; B=1; C=1; D=1; E=1; F=1; G=1; break;
  case 'u': A=1; B=1; C=0; D=0; E=0; F=1; G=1; break;
  case 'c': A=1; B=1; C=1; D=0; E=0; F=1; G=0; break;
  case 'b': A=1; B=1; C=0; D=0; E=0; F=0; G=0; break;
  case 't': A=1; B=1; C=1; D=0; E=0; F=0; G=0; break;
  case 'l': A=1; B=1; C=1; D=0; E=0; F=1; G=1; break;
  case 'o': A=1; B=1; C=0; D=0; E=0; F=1; G=0; break;
  case 'A': A=0; B=0; C=0; D=1; E=0; F=0; G=0; break;
  case 'H': A=1; B=0; C=0; D=1; E=0; F=0; G=0; break;
  case 'C': A=0; B=1; C=1; D=0; E=0; F=0; G=1; break;
  case 'P': A=0; B=0; C=1; D=1; E=0; F=0; G=0; break;
  case 'E': A=0; B=1; C=1; D=0; E=0; F=0; G=0; break;
  case 'U': A=1; B=0; C=0; D=0; E=0; F=0; G=1; break;
  case 'F': A=0; B=1; C=1; D=1; E=0; F=0; G=0; break;
  case 'L': A=1; B=1; C=1; D=0; E=0; F=0; G=1; break;
  case 'r': A=1; B=1; C=1; D=1; E=0; F=1; G=0; break;
  case '_': A=1; B=1; C=1; D=0; E=1; F=1; G=1; break;
  case 'd': A=1; B=0; C=0; D=0; E=0; F=1; G=0; break;
  case 'n': A=1; B=1; C=0; D=1; E=0; F=1; G=0; break;
  case '': A=0; B=0; C=1; D=1; E=1; F=0; G=1; break;
  case 'O': A=0; B=0; C=0; D=0; E=0; F=0; G=1; break;
  default:  A=1; B=1; C=1; D=1; E=1; F=1; G=0; break; //-
 }

   switch (pc)
 {
  case 0: N0=1; if(dpp == 0) {DP=0;} break;
  case 1: N1=1; if(dpp == 1) {DP=0;} break;
  case 2: if(dbuf[2]){N2=1;} if(dpp == 2) {DP=0;} break;
  default: DP=1; break;
 }
 }
void scan_keys ()
{
#define lp  4
#define lh  10
#define lr  2

static u8 count[6];

if ((!key0)&&(!tkey[0])) {count[0]++;tkey[0]=lr;}
  else if((key0)&&(!tkey[0])) {count[0]=count[1]=0;btn0=rls;}
if ((count[0]>lp)&&(btn0!=hold)) {btn0=prs; count[0]=0; count[1]++;}
//if (count[1]>lh) {btn0=hold; count[1]=0;}

if ((!key1)&&(!tkey[1])) {count[2]++;tkey[1]=lr;}
  else if((key1)&&(!tkey[1])) {count[3]=count[2]=0;btn1=rls;}
if ((count[2]>lp)&&(btn1!=hold)) {btn1=prs; count[2]=0; count[3]++;}
//if (count[3]>lh) {btn1=hold; count[3]=0;}
/*
if ((!key2)&&(!tkey[2])) {count[4]++;tkey[2]=lr;}
  else if((key2)&&(!tkey[2])) {count[5]=count[4]=0;btn2=rls;}
if ((count[4]>0xf0)&&(btn2!=hold)) {btn2=prs; count[4]=0; count[5]++;}
if (count[5]>lh) {btn2=hold; count[5]=0;}
*/
}

struct encoder_struct
{
 s16* value;
 s16  val_min;
 s16  val_max;
 u8   step;
 u8   cycle_form;
}encoder_data={&def_tmp,0,100,1,0};

void scan_enc (struct encoder_struct sst)
{
u8 New; bool a1,a0;
static u8 EncState;

if(btn0==rls) a0=1; else a0=0;
if(btn1==rls) a1=1; else a1=0;
New = (a1<<1)+a0;

switch(EncState)
{
case 0:
{
if(New == 2)
  if(*sst.value<sst.val_max-sst.step)*sst.value+=sst.step;
  else if(!sst.cycle_form)*sst.value=sst.val_min;
  else *sst.value=sst.val_max;
if(New == 1)
  if(*sst.value>sst.val_min+sst.step)*sst.value-=sst.step;
  else if(!sst.cycle_form)*sst.value=sst.val_max;
  else *sst.value=sst.val_min;
break;
}
case 1:
{
if(New == 0)
  if(*sst.value<sst.val_max-sst.step)*sst.value+=sst.step;
  else if(!sst.cycle_form)*sst.value=sst.val_min;
  else *sst.value=sst.val_max;
if(New == 3)
  if(*sst.value>sst.val_min+sst.step)*sst.value-=sst.step;
  else if(!sst.cycle_form)*sst.value=sst.val_max;
  else *sst.value=sst.val_min;
break;
}
case 2:
{
if(New == 3)
  if(*sst.value<sst.val_max-sst.step)*sst.value+=sst.step;
  else if(!sst.cycle_form)*sst.value=sst.val_min;
  else *sst.value=sst.val_max;
if(New == 0)
  if(*sst.value>sst.val_min+sst.step)*sst.value-=sst.step;
  else if(!sst.cycle_form)*sst.value=sst.val_max;
  else *sst.value=sst.val_min;
break;
}
case 3:
{
if(New == 1)
  if(*sst.value<sst.val_max-sst.step)*sst.value+=sst.step;
  else if(!sst.cycle_form)*sst.value=sst.val_min;
  else *sst.value=sst.val_max;
if(New == 2)
  if(*sst.value>sst.val_min+sst.step)*sst.value-=sst.step;
  else if(!sst.cycle_form)*sst.value=sst.val_max;
  else *sst.value=sst.val_min;
break;
}
}

EncState = New;
}

u16 read_ee_freq()
 {
  for(u8 i=0;i<msize;i++)
   {
     if (ee_freq[i]!=0xffff) return ee_freq[i];
   }
  return 0xffff;
 }
void write_ee_freq (u16 data)
{
 for(u8 i=0;i<msize;i++)
 {
   if(ee_freq[i]==data) return;

   if(ee_freq[i]!=0xffff)
    {
      FLASH_Unlock(FLASH_MEMTYPE_DATA);
      if(i<msize-1)
      {
       ee_freq[i+1]=data;
       ee_freq[i]=0xffff;
      }
     else
      {
       ee_freq[0]=data;
       ee_freq[i]=0xffff;
      }
      FLASH_Lock(FLASH_MEMTYPE_DATA);
      return;
    }
   else if(i==msize-1)
    {
      FLASH_Unlock(FLASH_MEMTYPE_DATA);
      ee_freq[0]=data;
      FLASH_Lock(FLASH_MEMTYPE_DATA);
    }
 }

}

void devcon(),pwm_on(),pwm_off(), sw_recalc(u16 new_freq);

INTERRUPT_HANDLER(TIM1_X3, 11)
{
 static u16 a=0,b=(s_step*2)/3,c=(s_step*2*2)/3;
 static u16 step_tmp=s_step;
 static u8 mst=pwm_top+pwm_top*4/16;
 u8 tmp;

 static u8 moe=0;

 if(!(TIM1->BKR&TIM1_BKR_MOE))
  {
    if(moe<0x0f){moe++; TIM1->BKR |= TIM1_BKR_MOE;}
    else {dev_st=ocp;}
  }
 else moe=0;

 switch(a/(step_tmp>>1))
 {
 case 0: tmp=(((u16)s_table [a]*mst)>>7);
         if(tmp>pwm_top){TIM1->CCR1L=pwm_top*2;}
         else{TIM1->CCR1L=0x80+tmp;}
         a++;break;
 case 1: tmp=(((u16)s_table [(step_tmp-1)-a]*mst)>>7);
         if(tmp>pwm_top){TIM1->CCR1L=pwm_top*2;}
         else{TIM1->CCR1L=0x80+tmp;}
         a++;break;
 case 2: tmp=(((u16)s_table [a-step_tmp]*mst)>>7);
         if(tmp>pwm_top)TIM1->CCR1L=0;
         else TIM1->CCR1L=0x7f-tmp;
         a++;break;
 case 3: tmp=(((u16)s_table [((step_tmp-1)<<1)-a]*mst)>>7);
         if(tmp>pwm_top)TIM1->CCR1L=0;
         else TIM1->CCR1L=0x7f-tmp;
         a++;break;
 case 4: a=0;
         if(!cntfb1)
         {
           cntfb1=1;step_tmp=step_exc;b=(step_tmp<<1)/3;c=(step_tmp<<2)/3;
           for(u8 i=0;i<(step_tmp>>1);i++)s_table[i]=s_table_tmp[i];
         }
         break;
 default:break;
 }

 switch(b/(step_tmp>>1))
 {
 case 0: tmp=(((u16)s_table [b]*mst)>>7);
         if(tmp>pwm_top){TIM1->CCR2L=pwm_top*2;}
         else{TIM1->CCR2L=0x80+tmp;}
         b++;break;
 case 1: tmp=(((u16)s_table [(step_tmp-1)-b]*mst)>>7);
         if(tmp>pwm_top){TIM1->CCR2L=pwm_top*2;}
         else{TIM1->CCR2L=0x80+tmp;}
         b++;break;
 case 2: tmp=(((u16)s_table [b-step_tmp]*mst)>>7);
         if(tmp>pwm_top)TIM1->CCR2L=0;
         else TIM1->CCR2L=0x7f-tmp;
         b++;break;
 case 3: tmp=(((u16)s_table [((step_tmp-1)<<1)-b]*mst)>>7);
         if(tmp>pwm_top)TIM1->CCR2L=0;
         else TIM1->CCR2L=0x7f-tmp;
         b++;break;
 case 4: b=0;break;
 default:break;
 }

 switch(c/(step_tmp>>1))
 {
 case 0: tmp=(((u16)s_table [c]*mst)>>7);
         if(tmp>pwm_top){TIM1->CCR3L=pwm_top*2;}
         else{TIM1->CCR3L=0x80+tmp;}
         c++;break;
 case 1: tmp=(((u16)s_table [(step_tmp-1)-c]*mst)>>7);
         if(tmp>pwm_top){TIM1->CCR3L=pwm_top*2;}
         else{TIM1->CCR3L=0x80+tmp;}
         c++;break;
 case 2: tmp=(((u16)s_table [c-step_tmp]*mst)>>7);
         if(tmp>pwm_top)TIM1->CCR3L=0;
         else TIM1->CCR3L=0x7f-tmp;
         c++;break;
 case 3: tmp=(((u16)s_table [((step_tmp-1)<<1)-c]*mst)>>7);
         if(tmp>pwm_top)TIM1->CCR3L=0;
         else TIM1->CCR3L=0x7f-tmp;
         c++;break;
 case 4: c=0;
         if(!cntfb){cntfb=1;mst=x;}
         break;
 default:break;
 }

 TIM1->SR1 = 0;
}

INTERRUPT_HANDLER(TIM2_OVF, 13)
{
 scan_keys ();
 scan_enc (encoder_data);

 if(tkey[0])tkey[0]--; if(tkey[1])tkey[1]--;// if(tkey[2])tkey[2]--;
 if(tim0)tim0--;
 if(tim1)tim1--;
// if(tmr0)tim0--;
// if(tmr1)tim1--;

  TIM2->SR1 = 0;
}

void main()
{
gpio_cfg();
clk_cfg();
ITC_SetSoftwarePriority(ITC_IRQ_TIM1_OVF, ITC_PRIORITYLEVEL_3);
ITC_SetSoftwarePriority(ITC_IRQ_TIM2_OVF, ITC_PRIORITYLEVEL_1);

for(u8 i=0;i<s_step/2;i++) s_table[i]=(u8)((float)pwm_top*sin(((3.1416/2)*i)/(s_step/2-1)));

/* //3-rd harmonic V1
//  for(u8 i=0;i<s_step/2;i++) s_table[i]=(u8)((float)pwm_top*sin(((1.4*3.1416/2)*i)/(s_step/2-1)));

 { //3-rd harmonic V0
  u16 tmp;
  s_table[i]=(u8)((float)(pwm_top+pwm_top/12)*sin(((PI/2)*i)/(s_step/2-1)));
  tmp=(s16)((float)pwm_top*sin(((3*PI/2)*i)/(s_step/2-1)));
  if(tmp>pwm_top)st_tmp=(s16)-((float)pwm_top*sin(((3*PI/2)*n++)/(s_step/2-1)));
  else st_tmp=tmp;
  st_tmp/=3;
  s_table[i]=(s8)s_table[i]+st_tmp;
 }
*/


t1_cfg();
t2_cfg();


if((read_ee_freq()==0)||(read_ee_freq()>400))write_ee_freq(200);


asm("rim");


  while(1)
  {

	display_data();
        devcon();


  }
}

void assert_failed(uint8_t* file, uint32_t line){}

void devcon()
 {
  static bool itr=0;
  static u16 freq;


  switch(dev_st)
  {
   case run:
    {
    if(!itr)
    {
    itr=1; tim0=0xffff/4;
    convert_data(read_ee_freq());dbuf[0]='r';
    freq=read_ee_freq();

    }

    if((cntfb1)&&(!tim0)){dev_st=norm; sw_recalc(freq); pwm_on();}
    if(dev_st!=run){itr=0;}
    }
    return;

   case norm:
    {
    static u16 freq_tmp;
   // static bool f_trg;

    if(!itr)
    {
    itr=1;
    freq_tmp=def_tmp=freq;
    encoder_data.val_max=400;
    encoder_data.val_min=50;
    encoder_data.step=1;
    encoder_data.cycle_form=1;
    encoder_data.value = &def_tmp;
    dpp=5;
    }

    if(!tim0){tim0=1000; convert_data(def_tmp);}

    if((def_tmp!=freq_tmp)&&(!tim1)){tim1=0xffff/4;freq_tmp=def_tmp;dpp=0;}
    if((def_tmp==freq_tmp)&&(!tim1)&&(freq_tmp!=freq))
     {
       freq=freq_tmp;
       if(freq!=read_ee_freq())write_ee_freq(freq);
       sw_recalc(freq);
       dpp=5;
     }







    if(dev_st!=norm){itr=0;}
    }
    return;


   case ocp:
    {

     dbuf[2]='O';dbuf[1]='C';dbuf[0]='P';dpp=3;
     pwm_off();

    }
    return;
  }
 }

void pwm_on()
 {
  TIM1->BKR |= TIM1_BKR_MOE;
 }
void pwm_off()
 {
  TIM1->BKR &= ~TIM1_BKR_MOE;
 }
void sw_recalc(u16 new_freq)
{
  step_exc = pwm_freq/(2*new_freq);
  for(u8 i=0;i<step_exc/2;i++) s_table_tmp[i]=(u8)((float)pwm_top*sin(((3.1416/2)*i)/(step_exc/2-1)));
  //while(cntfb1);
  cntfb1=0;
}

